/**
 * 
 * @authors Nat Liu (natcube@gmail.com)
 * @date    2014-12-08 16:10:26
 * @version 2014-12-08 16:10:26
 */

$(function(){

	$("#s-activities").sudyfocus({
		p:8,
		zWidth:286,
		zHeight:90,
		response:true
	});


	// nenuimg - plugin
	var nenuimgCurMonth = Number(clientDate.Format("M")),
		nenuimgAuto = true,
		nenuimgSpeed = 700,
		nenuimgRunning = true,
		nenuimgInterval = 5000,
		nenuimgTimer,
		nenuimgPause = true,
		nenuimgJSONindex,
		nenuimgIndex = {},
		nenuimgHeight,
		nenuimgWidth,
		nenuimgNavWidth,
		nenuimgs = [],
		preloadNum = 1, // 预加载的图片最大数目
		$nenuimg = $(".nenuimg-image"),
		$nenuimgLink = $(".nenuimg-link"),
		$nenuimgMonth = $(".nenuimg-month"),
		$nenuimgList = $("#nenuimg-year"),
		nenuimglist = $("#nenuimg-year").attr('href');

	function resizeNenuimg(){

		nenuimgWidth = $(window).width();
        nenuimgHeight = 370;
        nenuimgNavWidth = 1200;
		if(nenuimgWidth<1200){

			nenuimgHeight = nenuimgWidth*9/24;
			nenuimgNavWidth = nenuimgWidth < 1000 ? nenuimgWidth : 1000;
		}else{

			nenuimgWidth = 1200;
		}

		$nenuimgLink.css({"height":nenuimgHeight});
		$(".nenuimg-prev").css("margin-left",20-nenuimgNavWidth/2);
		$(".nenuimg-next").css("margin-right",20-nenuimgNavWidth/2);
	}

	// 自适应尺寸

	resizeNenuimg();

	// 过滤数据，预加载每个月份的第一张图片

	function preload(){

		var preimg=[],imgindex = [], index;
		for(var ii=12;ii>=1;ii--)
		{
			index = "m" + ii; 
			if(nenuimgJSON[index].length>0){

				preimg[ii] = new Image();
				preimg[ii].id = ii + "-" + 0;
				nenuimgIndex[index] = 0;
				preimg[ii].onload = function(){

					nenuimgs[this.id] = this;
				}
				preimg[ii].src = isMobile ? nenuimgJSON[index][0].src : nenuimgJSON[index][0].original;
			}else{

				$("li",$nenuimgMonth).eq(ii-1).addClass('noimg');
			}
		}
	}

	// 预加载
	preload();

	// 获取前面有图片月份
	function getPrevImgMonth(){

		var cur = nenuimgCurMonth;

		for (var i = cur - 1; i >= 1; i--) {

			if(nenuimgJSON["m"+i]){
				return i;
			}
		};
		
		return cur;
	}

	// 获取后面有图片月份
	function getNextImgMonth(){

		var cur = nenuimgCurMonth;

		for (var i = cur + 1; i <= 12; i++) {

			if(nenuimgJSON["m"+i]){
				return i;
			}
		};
		
		return cur;
	}

	function showPrevNenuImg(){

		var monthIndex = "m"+nenuimgCurMonth,
			index = nenuimgIndex[monthIndex];
		index--;
		if(index<0){
			index = nenuimgJSON[monthIndex].length-1;
		}
		if(nenuimgIndex[nenuimgJSONindex]!==index)
		showNenuImg(nenuimgCurMonth,index);
	}

	function showNextNenuImg(){
		var monthIndex = "m"+nenuimgCurMonth,
			index = nenuimgIndex[monthIndex];
		index++;
		if(index>nenuimgJSON[monthIndex].length-1){
			index = 0;
		}
		if(nenuimgIndex[nenuimgJSONindex]!==index)
		showNenuImg(nenuimgCurMonth,index);
	}

	function autoNenuimg(interval){

		if(nenuimgAuto&&nenuimgRunning){
			nenuimgTimer = setTimeout(function(){
				showNextNenuImg();
			}, interval||2000);
		}

	}

	function setNenuAttr(image,index){

		$nenuimg.attr({"src":image.src});
		//$nenuimg.animate({opacity:'show',left:0},nenuimgSpeed );//原始效果
                $nenuimg.animate({left:0},nenuimgSpeed );//修改效果
                $nenuimg.show();                         //修改效果

		var href = nenuimgJSON[nenuimgJSONindex][index].url;
		var isBlankHref = /^http|https|ftp/.test(href);
		var noHref = /^(#)|^(无链接)/.test(href);
		var attr = {};
		if(noHref){
			$nenuimgLink.addClass('nolink');
		}else{
			attr.href = href;
			attr.target = "_blank";

			$nenuimgLink.removeClass('nolink');
		}
		$nenuimgLink.removeAttr('href target').attr(attr);
                $nenuimgList.removeAttr('target');
		autoNenuimg(nenuimgInterval);
	}
	
	// 预加载本月前后一张图片
	function preloadNext(month,index){
		
		if(nenuimgJSON[nenuimgJSONindex]){
			var next = index + 1;
			var prev = index - 1;
			var monthImgs = nenuimgJSON[nenuimgJSONindex];
			if(monthImgs[next]){
				var nextimg = new Image();
				nextimg.src = isMobile ? monthImgs[next].src : monthImgs[next].original;
			}
			
			if(monthImgs[prev]){
				var previmg = new Image();
				previmg.src = isMobile ? monthImgs[prev].src : monthImgs[prev].original;
			}

		}
	}

	function showNenuImg(month,index){

		nenuimgJSONindex = "m" + month;
		if(nenuimgJSON[nenuimgJSONindex]&&nenuimgJSON[nenuimgJSONindex][index]){
			$nenuimg.css("left","20px").hide();
			$nenuimgLink.removeAttr('href target');
			nenuimgCurMonth = month;
			nenuimgIndex[nenuimgJSONindex] = index;
			var imageId = month + "-" + index;
			if(nenuimgs[imageId]){

				setNenuAttr(nenuimgs[imageId],index);
			}else{
				var nenuimg = new Image();
				nenuimg.id = imageId;
				nenuimg.onload=function(){

						nenuimgs[this.id] = this;
						setNenuAttr(this,index);
						preloadNext(nenuimgJSONindex,index);
				}

				nenuimg.src = isMobile ? nenuimgJSON[nenuimgJSONindex][index].src : nenuimgJSON[nenuimgJSONindex][index].original;
			}
			// 高亮显示当前月份标签
			$("li", $nenuimgMonth).removeClass('current-month').eq(month-1).addClass('current-month');
			$nenuimgList.attr({	
				'href': 'javascript:;'
				//'title': ''
			});

			$(".nenuimg-navigation").hide();
			if(nenuimgJSON[nenuimgJSONindex][index+1]){
				$(".nenuimg-next").show();
			}
			if(nenuimgJSON[nenuimgJSONindex][index-1]){
				$(".nenuimg-prev").show();
			}
		}else{

			return false;
		}
	}

	$(".nenuimg-prev").on('click', function(event) {
		event.preventDefault();
		/* Act on the event */
		clearTimeout(nenuimgTimer);
		showPrevNenuImg();
	});

	$(".nenuimg-next").on('click', function(event) {
		event.preventDefault();
		/* Act on the event */
		clearTimeout(nenuimgTimer);
		showNextNenuImg();
	});

	$("li",$nenuimgMonth).on('click', function(event) {
		event.preventDefault();
		/* Act on the event */
		var thismonth = $(this).index()+1;
		var index = nenuimgIndex["m"+thismonth];
		clearTimeout(nenuimgTimer);
		showNenuImg(thismonth,index);
	});

	if(nenuimgPause){

		$nenuimgLink.on('mouseenter', function(event) {
			clearTimeout(nenuimgTimer);
			nenuimgRunning = false;
		}).on('mouseleave', function(event) {
			nenuimgRunning = true;
			autoNenuimg(nenuimgInterval/2);
		});
	}

	// 是否支持触屏
    if($.fn.sudyTouch){
        $nenuimg.sudyTouch({
            "swipeLeft": function(){
               	showNextNenuImg();
            },
            "swipeRight": function(){
                showPrevNenuImg();
            }
        });
    }


	// nenuimg初始化，加载最近一个有图片月份的第一张图

	if(nenuimgJSON["m"+nenuimgCurMonth]){
		showNenuImg(nenuimgCurMonth,0);
                $nenuimgList.text( clientDate.getFullYear() );
	}else{
		showNenuImg(getPrevImgMonth(),0);
	}


	$(window).resize(function(event) {
		/* Act on the event */
		resizeNenuimg();
	});

});